package n9m

type PayloadType uint8

const (
	PayloadTypeData                  PayloadType = 0
	PayloadTypeLive                  PayloadType = 2
	PayloadTypeDownload              PayloadType = 3
	PayloadTypePlayback              PayloadType = 4
	PayloadTypeCapturedPhotos        PayloadType = 6
	PayloadTypeParameterImport       PayloadType = 10
	PayloadTypeParameterExport       PayloadType = 11
	PayloadTypeTransmissionSubStream PayloadType = 15
	PayloadTypeRecordingSubStream    PayloadType = 16
	PayloadTypeBlackBox              PayloadType = 17
	PayloadTypeGPS                   PayloadType = 22
	PayloadTypeMaintainData          PayloadType = 30
)

type Message struct {
	Module    string      `json:"MODULE"`
	Session   string      `json:"SESSION"`
	Operation string      `json:"OPERATION"`
	Parameter interface{} `json:"PARAMETER,omitempty"`
	Response  interface{} `json:"RESPONSE,omitempty"`
}

type Package struct {
	Version        uint8
	EncryptionFlag bool
	CompressFlag   bool
	CSRCCount      uint8

	PayloadType PayloadType
	SSRC        uint16
	Reserved    uint64
	CSRC        [16]uint64

	payloadLen uint64
	Payload    Message
	RawPayload []byte

	Accum []byte
}
